From 5b2deaa0e51468a04a3c7c72ad8e5181a8e804e2 Mon Sep 17 00:00:00 2001 From: Paul Buetow Date: Sun, 28 May 2023 00:01:27 +0300 Subject: Update content for html --- gemfeed/2022-01-01-bash-golf-part-2.html | 90 ++++++++++++++++---------------- 1 file changed, 45 insertions(+), 45 deletions(-) (limited to 'gemfeed/2022-01-01-bash-golf-part-2.html') diff --git a/gemfeed/2022-01-01-bash-golf-part-2.html b/gemfeed/2022-01-01-bash-golf-part-2.html index 93ccdb64..76890581 100644 --- a/gemfeed/2022-01-01-bash-golf-part-2.html +++ b/gemfeed/2022-01-01-bash-golf-part-2.html @@ -13,24 +13,24 @@ Published at 2022-01-01T23:36:15+00:00; Updated at 2022-01-05

-    '\       '\                   .  .                |>18>>
-      \        \              .         ' .           |
-     O>>      O>>         .                 'o        |
+    '\       '\                   .  .                |>18>>
+      \        \              .         ' .           |
+     O>>      O>>         .                 'o        |
       \       .\. ..   .                              |
       /\    .  /\    . .                              |
-     / /   .  / /  .'    .                            |
+     / /   .  / /  .'    .                            |
 jgs^^^^^^^`^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                         Art by Joan Stark, mod. by Paul Buetow
 

-This is the second blog post about my Bash Golf series. This series is random Bash tips, tricks and weirdnesses I came across. It's a collection of smaller articles I wrote in an older (in German language) blog, which I translated and refreshed with some new content.
+This is the second blog post about my Bash Golf series. This series is random Bash tips, tricks and weirdnesses I came across. It's a collection of smaller articles I wrote in an older (in German language) blog, which I translated and refreshed with some new content.

2022-01-01 Bash Golf Part 2 (You are currently reading this)
2021-11-29 Bash Golf Part 1

Redirection



-Let's have a closer look at Bash redirection. As you might already know that there are 3 standard file descriptors:
+Let's have a closer look at Bash redirection. As you might already know that there are 3 standard file descriptors:


-It is, however, not possible to redirect multiple times within the same command. E.g. the following won't work. You would expect stdin to be redirected to stderr and then stderr to be redirected to /dev/null. But as the example shows, Foo is still printed out:
+It is, however, not possible to redirect multiple times within the same command. E.g. the following won't work. You would expect stdin to be redirected to stderr and then stderr to be redirected to /dev/null. But as the example shows, Foo is still printed out:

 ❯ echo Foo 1>&2 2>/dev/null
@@ -93,7 +93,7 @@ Foo
 ❯
 

-A handy way to list all open file descriptors is to use the "lsof" command (that's not a Bash built-in), whereas $$ is the process id (pid) of the current shell process:
+A handy way to list all open file descriptors is to use the "lsof" command (that's not a Bash built-in), whereas $$ is the process id (pid) of the current shell process:

 ❯ lsof -a -p $$ -d0,1,2
@@ -103,7 +103,7 @@ bash    62676 paul    1u   CHR  136,9      0t0   12 /dev/pts/9
 bash    62676 paul    2u   CHR  136,9      0t0   12 /dev/pts/9
 

-Let's create our own descriptor "3" for redirection to a file named "foo":
+Let's create our own descriptor "3" for redirection to a file named "foo":

 ❯ touch foo
@@ -149,7 +149,7 @@ echo Second line: $LINE2
 exec 0<&6 6<&-
 

-Let's execute it:
+Let's execute it:

 ❯ chmod 750 ./grandmaster.sh
@@ -160,7 +160,7 @@ Second line: for Great Good
 

HERE



-I have mentioned HERE-documents and HERE-strings already in this post. Let's do some more examples. The following "cat" receives a multi line string from stdin. In this case, the input multi line string is a HERE-document. As you can see, it also interpolates variables (in this case the output of "date" running in a subshell).
+I have mentioned HERE-documents and HERE-strings already in this post. Let's do some more examples. The following "cat" receives a multi line string from stdin. In this case, the input multi line string is a HERE-document. As you can see, it also interpolates variables (in this case the output of "date" running in a subshell).

 ❯ cat <<END
@@ -168,10 +168,10 @@ Second line: for Great Good
 > It’s $(date)
 > END
 Hello World
-It's Fri 26 Nov 08:46:52 GMT 2021
+It's Fri 26 Nov 08:46:52 GMT 2021
 

-You can also write it the following way, but that's less readable (it's good for an obfuscation contest):
+You can also write it the following way, but that's less readable (it's good for an obfuscation contest):

 ❯ <<END cat
@@ -179,7 +179,7 @@ It's Fri 26 Nov 08:46:52 GMT 2021
 > It’s $(date)
 > END
 Hello Universe
-It's Fri 26 Nov 08:47:32 GMT 2021
+It's Fri 26 Nov 08:47:32 GMT 2021
 

Besides of an HERE-document, there is also a so-called HERE-string. Besides of...
@@ -187,7 +187,7 @@ It's Fri 26 Nov 08:47:32 GMT 2021
 ❯ declare VAR=foo
 ❯ if echo "$VAR" | grep -q foo; then
-> echo '$VAR ontains foo'
+> echo '$VAR ontains foo'
 > fi
 $VAR ontains foo
 
@@ -196,7 +196,7 @@ $VAR ontains foo
 ❯ if grep -q foo <<< "$VAR"; then
-> echo '$VAR contains foo'
+> echo '$VAR contains foo'
 > fi
 $VAR contains foo
 
@@ -204,7 +204,7 @@ $VAR contains foo Or even shorter, you can do:

-❯ grep -q foo <<< "$VAR" && echo '$VAR contains foo'
+❯ grep -q foo <<< "$VAR" && echo '$VAR contains foo'
 $VAR contains foo
 

@@ -221,10 +221,10 @@ yay ❯ read a <<< ja ❯ echo $a ja -❯ read b <<< 'NEIN!!!' +❯ read b <<< 'NEIN!!!' ❯ echo $b NEIN!!! -❯ dumdidumstring='Learn you a Golang for Great Good' +❯ dumdidumstring='Learn you a Golang for Great Good' ❯ read -a words <<< "$dumdidumstring" ❯ echo ${words[0]} Learn @@ -235,7 +235,7 @@ Golang The following is good for an obfuscation contest too:

-❯ echo 'I like Perl too' > perllove.txt
+❯ echo 'I like Perl too' > perllove.txt
 ❯ cat - perllove.txt <<< "$dumdidumstring"
 Learn you a Golang for Great Good
 I like Perl too
@@ -243,7 +243,7 @@ I like Perl too
 

RANDOM



-Random is a special built-in variable containing a different pseudo random number each time it's used.
+Random is a special built-in variable containing a different pseudo random number each time it's used.

 ❯ echo $RANDOM
@@ -254,9 +254,9 @@ I like Perl too
 9104
 

-That's very useful if you want to randomly delay the execution of your scripts when you run it on many servers concurrently, just to spread the server load (which might be caused by the script run) better.
+That's very useful if you want to randomly delay the execution of your scripts when you run it on many servers concurrently, just to spread the server load (which might be caused by the script run) better.

-Let's say you want to introduce a random delay of 1 minute. You can accomplish it with:
+Let's say you want to introduce a random delay of 1 minute. You can accomplish it with:

 ❯ cat ./calc_answer_to_ultimate_question_in_life.sh
@@ -268,7 +268,7 @@ random_delay () {
     local -i sleep_for=$((RANDOM % MAX_DELAY))
     echo "Delaying script execution for $sleep_for seconds..."
     sleep $sleep_for
-    echo 'Continuing script execution...'
+    echo 'Continuing script execution...'
 }
 
 main () {
@@ -288,7 +288,7 @@ Continuing script execution...
 

set -x and set -e and pipefile



-In my opinion, -x and -e and pipefile are the most useful Bash options. Let's have a look at them one after another.
+In my opinion, -x and -e and pipefile are the most useful Bash options. Let's have a look at them one after another.

-x



@@ -302,7 +302,7 @@ Continuing script execution... ++ square 11 ++ local -i num=11 ++ echo 121 -+ echo 'Square of 11 is 121' ++ echo 'Square of 11 is 121' Square of 11 is 121

@@ -312,7 +312,7 @@ Square of 11 is 121 ❯ bash -x ./half_broken_script_to_be_debugged.sh

-Let's do that on one of the example scripts we covered earlier:
+Let's do that on one of the example scripts we covered earlier:

 ❯ bash -x ./grandmaster.sh
@@ -336,7 +336,7 @@ Second line: for Great Good
 
This is a very important option you want to use when you are paranoid. This means, you should always "set -e" in your scripts when you need to make absolutely sure that your script runs successfully (with that I mean that no command should exit with an unexpected status code).

-Ok, let's dig deeper:
+Ok, let's dig deeper:

 ❯ help set | grep -- -e
@@ -346,7 +346,7 @@ Second line: for Great Good
 As you can see in the following example, the Bash terminates after the execution of "grep" as "foo" is not matching "bar". Therefore, grep exits with 1 (unsuccessfully) and the shell aborts. And therefore, "bar" will  not be printed out anymore:

-❯ bash -c 'set -e; echo hello; grep -q bar <<< foo; echo bar'
+❯ bash -c 'set -e; echo hello; grep -q bar <<< foo; echo bar'
 hello
 ❯ echo $?
 1
@@ -355,47 +355,47 @@ hello
 Whereas the outcome changes when the regex matches:

-❯ bash -c 'set -e; echo hello; grep -q bar <<< barman; echo bar'
+❯ bash -c 'set -e; echo hello; grep -q bar <<< barman; echo bar'
 hello
 bar
 ❯ echo $?
 0
 

-So does it mean that grep will always make the shell terminate whenever its exit code isn't 0? This will render "set -e" quite unusable. Frankly, there are other commands where an exit status other than 0 should not terminate the whole script abruptly. Usually, what you want is to branch your code based on the outcome (exit code) of a command:
+So does it mean that grep will always make the shell terminate whenever its exit code isn't 0? This will render "set -e" quite unusable. Frankly, there are other commands where an exit status other than 0 should not terminate the whole script abruptly. Usually, what you want is to branch your code based on the outcome (exit code) of a command:

-❯ bash -c 'set -e
+❯ bash -c 'set -e
 >    grep -q bar <<< foo
 >    if [ $? -eq 0 ]; then
 >        echo "matching"
 >    else
 >        echo "not matching"
->    fi'
+>    fi'
 ❯ echo $?
 1
 

-...but the example above won't reach any of the branches and won't print out anything, as the script terminates right after grep.
+...but the example above won't reach any of the branches and won't print out anything, as the script terminates right after grep.

The proper solution is to use grep as an expression in a conditional (e.g. in an if-else statement):

-❯ bash -c 'set -e
+❯ bash -c 'set -e
 >    if grep -q bar <<< foo; then
 >        echo "matching"
 >    else
 >        echo "not matching"
->    fi'
+>    fi'
 not matching
 ❯ echo $?
 0
-❯ bash -c 'set -e
+❯ bash -c 'set -e
 >    if grep -q bar <<< barman; then
 >        echo "matching"
 >    else
 >        echo "not matching"
->    fi'
+>    fi'
 matching
 ❯ echo $?
 0
@@ -413,7 +413,7 @@ foo () {
     local arg="$1"; shift
 
     if [ -z "$arg" ]; then
-        arg='You!'
+        arg='You!'
     fi
     echo "Hello $arg"
 }
@@ -426,7 +426,7 @@ bar () {
     set -e
 
     if [ -z "$arg" ]; then
-        arg='You!'
+        arg='You!'
     fi
     echo "Hello $arg"
 }
@@ -445,7 +445,7 @@ Hello Universe
 Hello You!
 

-Why does calling "foo" with no arguments make the script terminate? Because as no argument was given, the "shift" won't have anything to do as the argument list $@ is empty, and therefore "shift" fails with a non-zero status.
+Why does calling "foo" with no arguments make the script terminate? Because as no argument was given, the "shift" won't have anything to do as the argument list $@ is empty, and therefore "shift" fails with a non-zero status.

Why would you want to use "shift" after function-local variable assignments? Have a look at my personal Bash coding style guide for an explanation :-):

@@ -465,19 +465,19 @@ Hello You! The following greps for paul in passwd and converts all lowercase letters to uppercase letters. The exit code of the pipe is 0, as the last command of the pipe (converting from lowercase to uppercase) succeeded:

-❯ grep paul /etc/passwd | tr '[a-z]' '[A-Z]'
+❯ grep paul /etc/passwd | tr '[a-z]' '[A-Z]'
 PAUL:X:1000:1000:PAUL BUETOW:/HOME/PAUL:/BIN/BASH
 ❯ echo $?
 0
 

-Let's look at another example, where "TheRock" doesn't exist in the passwd file. However, the pipes exit status is still 0 (success). This is so because the last command ("tr" in this case) still succeeded. It is just that it didn't get any input on stdin to process:
+Let's look at another example, where "TheRock" doesn't exist in the passwd file. However, the pipes exit status is still 0 (success). This is so because the last command ("tr" in this case) still succeeded. It is just that it didn't get any input on stdin to process:

 ❯ grep TheRock /etc/passwd
 ❯ echo $?
 1
-❯ grep TheRock /etc/passwd | tr '[a-z]' '[A-Z]'
+❯ grep TheRock /etc/passwd | tr '[a-z]' '[A-Z]'
 ❯ echo $?
 0
 
@@ -486,7 +486,7 @@ PAUL:X:1000:1000:PAUL BUETOW:/HOME/PAUL:/BIN/BASH
 ❯ set -o pipefail
-❯ grep TheRock /etc/passwd | tr '[a-z]' '[A-Z]'
+❯ grep TheRock /etc/passwd | tr '[a-z]' '[A-Z]'
 ❯ echo $?
 1
 
-- cgit v1.2.3